import 'package:http/http.dart';
import 'package:interzone/disk.dart';

class OmniRemembers {
  //omni remembers whay you have seen and what is FRESH
  int get now => DateTime.now().millisecondsSinceEpoch;
  interzoneDisk? _io;
  Set<int> _seen = {};
  Set<int> _liked = {};
  String _ioSiteName = '';
  init(interzoneDisk io, String siteName) async {
    _io = io;
    _ioSiteName = siteName;
    final ri = await _io?.readUint64List(siteName + 'omniSeen');
    if (ri != null && ri.isNotEmpty) {
      _seen = ri.toSet();
    }
    final ra = await _io?.readUint64List(siteName + 'omniLiked');
    if (ra != null && ra.isNotEmpty) {
      _liked = ra.toSet();
    }
  }

  bool isSeen(int sli) {
    if (_seen.contains(sli)) return true;
    return false;
  }

  bool markSeen(int sli) {
    //set this entry as seen
    _seen.add(sli);
    _io?.commitUint64List(_seen.toList(), _ioSiteName + 'omniSeen');

    return true;
  }

  bool isLiked(int sli) {
    if (_liked.contains(sli)) return true;
    return false;
  }

  bool markLiked(int sli) {
    //set this entry as seen
    _liked.add(sli);
    _io?.commitUint64List(_liked.toList(), _ioSiteName + 'omniLiked');

    return true;
  }

  bool unmarkLiked(int sli) {
    //set this entry as seen
    _liked.remove(sli);
    _io?.commitUint64List(_liked.toList(), _ioSiteName + 'omniLiked');

    return true;
  }

  bool unPeekEntry(int sli) {
    //set this entry as seen
    if (!_seen.contains(sli)) return false;
    _seen.remove(sli);
    return true;
  }
}
